require 'rubygems'
require 'sinatra'
require 'flickraw'
require 'haml'
require File.dirname(__FILE__) + '/helpers/clippy'
require File.dirname(__FILE__) + '/helpers/flickr'
require 'sinatra/static_assets'
require 'builder'


set :haml, {:format => :html5 }

enable :sessions

FLICKR_USERNAME = 'pyrat'

before do
  FlickRaw.api_key="[add config here]"
  FlickRaw.shared_secret="[add config here]"
end

get "/" do
  @sets = get_sets
  haml :sets
end

get "/set/:photoset_id" do
  @photoset = get_set_photos({:photoset_id => params[:photoset_id]})
  @page_title = @photoset[:meta]["title"]
  haml :photoset
end

get "/random.rss" do
  @photos = get_random_photos
  @current_user = FLICKR_USERNAME
  base_url
  builder :random_rss
end

get "/random_image" do
  image_url = get_random_photo
  redirect image_url["url_o"]
end

get "/headers" do
  @request = request
  haml :headers
end

helpers do
  def base_url
    @base_url ||= "#{request.env['rack.url_scheme']}://#{request.env['HTTP_HOST']}"
  end
end
