require 'sinatra/base'

module Sinatra
  module FlickrHelper

    def get_sets
      person = flickr.people.findByUsername({:username => FLICKR_USERNAME})
      flickr.photosets.getList({:user_id => person["nsid"]})
    end

    def get_set_photos(options = {})
      photoset_info = flickr.photosets.getInfo(options)
      opts = {:extras => 'url_sq, url_t, url_s, url_m, url_o'}.merge(options)
      photoset = flickr.photosets.getPhotos(opts)
      photos = photoset["photo"]
      {:meta => photoset_info, :photos => photos}
    end
    
    def get_random_photos(number_of_photos = 5)
      random_photos = []
      number_of_photos.times do
        random_photos << get_random_photo
      end
      random_photos
    end
    
    def get_random_photo
      set = get_random_set
      get_random_photo_from(set)
    end
    
    def get_random_set
      @all_sets ||= get_sets
      @all_sets[rand(@all_sets.size)]
    end
    
    # TODO
    def get_random_photo_from(set)
      @set_photos ||= {}
      key = set["id"].to_sym
      @set_photos[key] ||= get_set_photos({:photoset_id => set["id"]})[:photos]
      @set_photos[key][rand(@set_photos[key].size)]
    end
    

  end
  helpers FlickrHelper
end
